/* DVB USB framework compliant Linux driver for the Opera1 DVB-S Card
 * DVB-T receiver.
 *
 * Copyright (C) 2006 Mario Hlawitschka (dh1pa@amsat.org)
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License as published by the Free
 *	Software Foundation, version 2.
 *
 * see Documentation/dvb/README.dvb-usb for more information
 */

#include "dvb-usb-common.h"
#include "dvb-usb.h"


#include <linux/firmware.h>

#include "opera1-fe.h"
#ifdef DVB_USB_LOG_PREFIX
#undef DVB_USB_LOG_PREFIX
#endif
#define DVB_USB_LOG_PREFIX "opera-s1"

// defined below

int opera_xilinx_load_firmware(struct dvb_usb_device *udev, const char *filename);
extern int opera_get_buffer(struct dvb_usb_device*dev, u8 type, u8 thing, u8*data, u8 len,u8* gdata,int glen);
extern int opera1_xilinx_send( struct dvb_usb_device*dev, u8 type, u8 thing, u8*data, u8 len);
extern int opera1_xilinx_send_async( struct dvb_usb_device*dev, u8 type, u8 thing, u8*data, u8 len,int req_type);
//dummydata="\x90\xf3\x21\x4d\xfa\xb2\xce\x68\xa6"; //size 9
static const char* xilinx_init="\x90\x6e\xc5\xfa\x32\xd0\x73\x23\x1e";
static int firmware_uploaded=0;
// stolen from vp702x
#define READ_FX2_REG_REQ  0xBA
#define WRITE_FX2_REG_REQ 0xBB

int dvb_usb_debug;
module_param_named(debug,dvb_usb_debug, int, 0644);
MODULE_PARM_DESC(debug, "set debugging level (1=info,xfer=2,pll=4,ts=8,err=16,rc=32,fw=64 (or-able))." DVB_USB_DEBUG_STATUS);


#if 0
static int mario_opera1_demod_init(struct dvb_frontend *fe)
{
	info("mario_opera1_demod_init");
	/*
	static u8 mario_opera1_clock_config[] = { 0x89, 0xb8, 0x2d };
	static u8 mario_opera1_reset[] = { 0x50, 0x80 };
	static u8 mario_opera1_mclk_ratio[] = { 0x8b, 0x00 };
	static u8 mario_opera1_adc_ctl_1_cfg[] = { 0x8E, 0x40 };
	static u8 mario_opera1_agc_cfg[] = { 0x67, 0x10, 0xa0 };

	static u8 mario_opera1_sec_agc_cfg1[] = { 0x6a, 0xff };
	static u8 mario_opera1_sec_agc_cfg2[] = { 0x6d, 0xff };
	static u8 mario_opera1_sec_agc_cfg3[] = { 0x70, 0x40 };
	static u8 mario_opera1_sec_agc_cfg4[] = { 0x7b, 0x03 };
	static u8 mario_opera1_sec_agc_cfg5[] = { 0x7d, 0x0f };

	static u8 mario_opera1_acq_ctl[] = { 0x53, 0x50 };
	static u8 mario_opera1_input_freq_1[] = { 0x56, 0x31, 0x06 };

	mario_opera1_write(fe, mario_opera1_clock_config, sizeof(mario_opera1_clock_config));
	udelay(2000);
	mario_opera1_write(fe, mario_opera1_reset, sizeof(mario_opera1_reset));
	mario_opera1_write(fe, mario_opera1_mclk_ratio, sizeof(mario_opera1_mclk_ratio));

	mario_opera1_write(fe, mario_opera1_adc_ctl_1_cfg, sizeof(mario_opera_adc_ctl_1_cfg));
	mario_opera1_write(fe, mario_opera1_agc_cfg, sizeof(mario_opera_agc_cfg));

	mario_opera1_write(fe, mario_opera1_sec_agc_cfg1, sizeof(mario_opera1_sec_agc_cfg1));
	mario_opera1_write(fe, mario_opera1_sec_agc_cfg2, sizeof(mario_opera1_sec_agc_cfg2));
	mario_opera1_write(fe, mario_opera1_sec_agc_cfg3, sizeof(mario_opera1_sec_agc_cfg3));
	mario_opera1_write(fe, mario_opera1_sec_agc_cfg4, sizeof(mario_opera1_sec_agc_cfg4));
	mario_opera1_write(fe, mario_opera1_sec_agc_cfg5, sizeof(mario_opera1_sec_agc_cfg5));

	mario_opera1_write(fe, mario_opera1_acq_ctl, sizeof(mario_opera1_acq_ctl));
	mario_opera1_write(fe, mario_opera1_input_freq_1, sizeof(mario_opera1_input_freq_1));
*/
	return 0;
}
#endif


static int mario_opera1_frontend_attach(struct dvb_usb_device *d)
{
	//sema_init(&d->usb_sem,1);
	d->fe = opera1_fe_attach(d);
	//struct stv0299_config opera1_config;
	info("mario_opera1_frontend_attach");
	//memset(&opera1_config,0,sizeof(struct stv0299_config));
	//opera1_config.demod_init = mario_opera1_demod_init;
	//opera1_config.demod_address = 0xf;
	//opera1_config.pll_set = dvb_usb_pll_set;

	//d->fe = stv0299_attach(&opera1_config, &d->i2c_adap);
	/*
	struct mario_opera1_config_t mario_opera1_config_t;

	memset(&umt_config,0,sizeof(struct mario_opera1_config_t));
	
	umt_config.demod_init = mario_opera_demod_init;
	umt_config.demod_address = 0xf;
	umt_config.pll_set = dvb_usb_pll_set;
	d->fe = mario_opera_attach(&umt_config, &d->i2c_adap);
	*/

	return 0;
}
#if 0 
static int mario_opera1_tuner_attach (struct dvb_usb_device *d)
{
	info( " mario_opera1_tuner_attach" );
	/*
	d->pll_addr = 0x61;
	d->pll_desc = &dvb_pll_tua6034;
	*/
	return 0;
}
#endif
/* USB Driver stuff */
static struct dvb_usb_properties mario_opera1_properties;

static int mario_opera1_probe(struct usb_interface *intf,
		const struct usb_device_id *id)
{
	info("mario_opera1_probe");

	info("mario_opera1_probe part 2");
	if (dvb_usb_device_init(intf,&mario_opera1_properties,THIS_MODULE,NULL) == 0)
		return 0;
	return -EINVAL;
}


int opera1_power_ctrl(struct dvb_usb_device *d, int onoff)
{
	int ret=0;

	info("power ctrl %d", onoff);
if (onoff)
	return 0;
	/*
	u8 b[3];
	int ret;
	b[0] = DIBUSB_REQ_SET_IOCTL;
	b[1] = DIBUSB_IOCTL_CMD_POWER_MODE;
	b[2] = onoff ? DIBUSB_IOCTL_POWER_WAKEUP : DIBUSB_IOCTL_POWER_SLEEP;
	ret = dvb_usb_generic_write(d,b,3);
	msleep(10);
	return ret;
	*/

	info(" writing fpga");
	if (!firmware_uploaded){
		ret = opera_xilinx_load_firmware(d, "opera1-fpga.fw");
		if (!ret)
		    firmware_uploaded=1;
	}
	info(" done fpga err=%d", ret);
	return 0;
}
static struct dvb_usb_rc_key opera1_rc_keys [] = {
	{ 0x1e, 0x00, KEY_0 },
	{ 0x1e, 0x01, KEY_1 },
	{ 0x1e, 0x02, KEY_2 },
	{ 0x1e, 0x03, KEY_3 },
};
static int opera1_rc_query(struct dvb_usb_device *dev, u32 *event, int *state)
{

	//ret = opera_xilinx_send(dev, 0xb8, 0x80, rcbuffer, 32);
	opera1_xilinx_send_async(dev,0xb1,0xd0,"\x16",1,QUERY_RC);

	return 0;
}

/* do not change the order of the ID table */
static struct usb_device_id mario_opera1_table [] = {
/* 00 */	{ USB_DEVICE(USB_VID_CYPRESS,		USB_PID_OPERA1_COLD         ) },
		{ USB_DEVICE(USB_VID_OPERA1_WARM,	USB_PID_OPERA1_WARM         ) },
/* 01 */	{ USB_DEVICE(USB_VID_CYPRESS,		USB_PID_OPERA1_COLD2         ) },
		{ USB_DEVICE(USB_VID_OPERA1_WARM,	USB_PID_OPERA1_WARM         ) },
			{ }		/* Terminating entry */
};
MODULE_DEVICE_TABLE (usb, mario_opera1_table);

static struct dvb_usb_properties mario_opera1_properties = {
	//.caps = DVB_USB_IS_AN_I2C_ADAPTER,
	//.caps = DVB_USB_HAS_PID_FILTER | DVB_USB_NEED_PID_FILTERING,
//	.usb_ctrl = CYPRESS_FLX2LP,

	.usb_ctrl = CYPRESS_FLX2LP,
	.firmware = "opera1.fw",

	.size_of_priv     = 0,//sizeof(struct dibusb_state),

	///.streaming_ctrl   = dibusb2_0_streaming_ctrl,
	.power_ctrl       = opera1_power_ctrl,
	.frontend_attach  = mario_opera1_frontend_attach,

	//.tuner_attach     = mario_opera1_tuner_attach,

//	.i2c_algo         = &dibusb_i2c_algo,
	//.i2c_algo         = &opera1_i2c_algo,
	.rc_key_map = opera1_rc_keys,
	.rc_key_map_size= ARRAY_SIZE(opera1_rc_keys),
	.rc_interval =  1000,
	.rc_query=opera1_rc_query,
	.generic_bulk_ctrl_endpoint = 0x00,
	/* parameter for the MPEG2-data transfer */
	.urb = {
		.type = DVB_USB_BULK,
		.count = 20,
		.endpoint = 0x06,
		.u = {
			.bulk = {
				.buffersize = 512,
			}
		}
	},

	.num_device_descs = 2,
	.devices = {
		{	"Mario Opera1 DVB-S USB2.0",
			{ &mario_opera1_table[0], NULL },
			{ &mario_opera1_table[1], NULL },
		},
		{	"Mario Opera1 DVB-S USB2.0 wrong product ID",
			{ &mario_opera1_table[2], NULL },
			{ &mario_opera1_table[3], NULL },
		},
	}
};

static struct usb_driver mario_opera1_driver = {
	//.owner		= THIS_MODULE,
	.name		= "mario_opera1",
	.probe		= mario_opera1_probe,
	.disconnect = dvb_usb_device_exit,
	.id_table	= mario_opera1_table,
};

/* module stuff */
static int __init mario_opera1_module_init(void)
{
	int result;
	info( "mario_opera1_module_init" );
	firmware_uploaded=0;
	if ((result = usb_register(&mario_opera1_driver))) {
		err("usb_register failed. Error number %d",result);
		return result;
	}

	return 0;
}

static void __exit mario_opera1_module_exit(void)
{
	info( "mario_opera1_module_exit" );
	/* deregister this driver from the USB subsystem */
	
	usb_deregister(&mario_opera1_driver);
}

module_init (mario_opera1_module_init);
module_exit (mario_opera1_module_exit);

MODULE_AUTHOR("Mario Hlawitschka (c) dh1pa@amsat.org, Marco Gittler (c) g.marco@freenet.de");
MODULE_DESCRIPTION("Driver for Opera1 DVB-S device");
MODULE_VERSION("0.0");
MODULE_LICENSE("GPL");
















static int opera_xilinx_write(struct usb_device *udev, u8 *data, u8 len)
{
	return usb_control_msg(udev, usb_sndctrlpipe(udev,0),
			WRITE_FX2_REG_REQ, USB_TYPE_VENDOR, 0x00, 0x00, data, len, 5*HZ);
}

static int opera_cypress_writemem(struct usb_device *udev,u16 addr,u8 *data, u8 len)
{
	return usb_control_msg(udev, usb_sndctrlpipe(udev,0),
			0xa0, USB_TYPE_VENDOR, addr, 0x00, data, len, 5*HZ);
}


		
int opera_xilinx_load_firmware(struct dvb_usb_device *dev, const char *filename)
{
	const struct firmware *fw = NULL;
	//int a;
	//u16 addr;
	u8 *b,*p;
	int ret = 0,i;

	char inbuffer[10];
	char dummydata[10];
	
	//dummydata = kmalloc(9,GFP_KERNEL);
	
	//printk("here\n");
	//info("\nhere\n");
	//if(!dummydata) return -EINVAL;

	memcpy(dummydata, xilinx_init, 9);

	for(i=0;i<10;++i) inbuffer[i]=0x00;

	//usb_control_msg dev pipe type request requesttype value index data size timeout
	// URB 04:
	info("URB4");
	//int dvb_usb_generic_write(struct dvb_usb_device *d, u8 *buf, u16 len)
	ret = opera1_xilinx_send(dev, 0xb1, 0xa0, dummydata, 9);
	deb_xfer("send : %d\n", ret);

	///ret=opera_xilinx_send(dev, 0xb1, 0x01, dummydata, 0);
	///deb_xfer("send : %d\n", ret);

	///info("URB6");
//	dummydata= {0x90};
//	send the 0x90 still in the buffer (why?)
	ret=opera1_xilinx_send(dev, 0xb1, 0xa0, dummydata, 1);
	deb_xfer("send : %d\n", ret);

	///info("URB7");
	///ret=opera_xilinx_send(dev, 0xb1, 0x01, dummydata, 0);
	///deb_xfer("send : %d\n", ret);
	
	info("URB8");
	//ret = opera_xilinx_send(dev, 0xb1, 0xa1, dummydata, 0);
	//deb_xfer("send : %d\n", ret);
	ret=usb_control_msg(dev->udev, usb_rcvctrlpipe(dev->udev,0),
			0xc0, 0xb1, 0x00a1, 0x0000, &inbuffer, 0x08, 20*HZ);
	deb_xfer("recv : %d\n", ret);
	deb_xfer("read buffer: ");
	debug_dump(inbuffer, 8, deb_xfer);

	///info("URB9");
	///ret=opera_xilinx_send(dev, 0xb1, 0x01, dummydata, 0);
	///deb_xfer("send : %d\n", ret);

	// wow, this operation needs a lot of time and
	// we have to wait a bit longer not to get a timeout
	// here.
	info("URB10");
	dummydata[0]='\x00';
	ret=opera1_xilinx_send(dev, 0xbc, 0xaa, dummydata, 1);
	deb_xfer("send : %d\n", ret);

	info("2");

	
	// is this turning the tuner off?
	// test is fpga-stuff  is loaded ??
	for ( i=0;i <4 ;i++){
		ret = opera1_xilinx_send(dev, 0xbc, 0x00, dummydata, 1);
		if ( ret!=0x2f )
			break;
	}
	if ( i==3)
		return 0;
	info("done init continue uploading FPGA stuff");
#if 1

#if 1 //fw
	info("debugging firmware upload....\n");
	if ((ret = request_firmware(&fw, filename, &dev->udev->dev)) != 0) {
		err("did not find the firmware file. (%s) "
			"Please see linux/Documentation/dvb/ for more details on firmware-problems.",
			filename);
		return ret;
	}

	info("downloading fpga firmware from file '%s'",filename);

	//info("Firmware info: size=%d 0x%04x   data=0x%02x 0x%02x", fw->size, fw->size, fw->data[0], fw->data[1]);
	p = kmalloc(fw->size,GFP_KERNEL);
	if (p != NULL) {
		u8 reset;
		/*
		 * you cannot use the fw->data as buffer for
		 * usb_control_msg, a new buffer has to be
		 * created
		 */
		memcpy(p,fw->data,fw->size);

		info("data: %02x %02x %02x %02x", p[0],p[1],p[2],p[3]);
		/* stop the CPU */
#if 0
		reset = 1;
		if ((ret = opera_cypress_writemem(dev->udev,0xe600/*cypress[type].cpu_cs_register*/,&reset,1)) != 1)
			err("could not stop the USB controller CPU.");
#endif
		for(i = 0; p[i] != 0 && i < fw->size; ) {
			
			b = (u8 *) p+i;
/*			addr = cpu_to_le16( *((u16 *) &b[1]) );

			info("writing to address 0x%04x (buffer: 0x%02x%02x)\n",addr,b[1],b[2]);

*/
			
			ret = opera_xilinx_write( dev->udev, b+1, b[0]);
			//ret = opera_cypress_writemem(udev,addr,&b[4],b[0]);
			//info("wrote: %02x %02x %02x %02x i=%d, size=%d", b[0],b[1],b[2],b[3],i,fw->size);
			if (ret != b[0]) {
				err("error while transferring firmware "
					"(transferred size: %d, block size: %d at addr %d)",
					ret,b[0],b[1]);
				ret = -EINVAL;
				break;
			}
			i = i+ 1 + b[0];
		}
#if 1
		/* length in ret */
		//ab URB 875
		if (ret > 0)
			ret = 0;
		/* restart the CPU */
		reset = 0;
		if (ret || opera_cypress_writemem(dev->udev,0xe600/*cypress[type].cpu_cs_register*/,&reset,1) != 1) {
			err("could not restart the USB controller CPU.");
			ret = -EINVAL;
		}
#endif
		info("upload done");
		kfree(p);
		info("p free'd");
	} else {
		info("something going wrong with upload");
		ret = -ENOMEM;
	}
	if (fw){
		info("rel firmware %s",filename);
		release_firmware(fw);
		info("rel firmware %s done",filename);
	}
#endif //fw

#endif
	/*info("rel dummy ");
	if (dummydata)
		kfree(dummydata);
	info("rel dummy done");*/
	return 0;//ret;
}
